#include "my_xlcd.h"

// DATA_PORT = data;               // Write data to port
void my_set_data_port(BYTE value)
  {
    DATA_PORT_0 = (value & 0b00000001);
    DATA_PORT_1 = (value & 0b00000010)>>1;
    DATA_PORT_2 = (value & 0b00000100)>>2;
    DATA_PORT_3 = (value & 0b00001000)>>3;
    DATA_PORT_4 = (value & 0b00010000)>>4;
    DATA_PORT_5 = (value & 0b00100000)>>5;
    DATA_PORT_6 = (value & 0b01000000)>>6;
    DATA_PORT_7 = (value & 0b10000000)>>7;    
  }

// DATA_PORT = data;               // Write data to port
void my_set_tris_data_port(BYTE value)
  {
    TRIS_DATA_PORT_0 = (value & 0b00000001);
    TRIS_DATA_PORT_1 = (value & 0b00000010)>>1;
    TRIS_DATA_PORT_2 = (value & 0b00000100)>>2;
    TRIS_DATA_PORT_3 = (value & 0b00001000)>>3;
    TRIS_DATA_PORT_4 = (value & 0b00010000)>>4;
    TRIS_DATA_PORT_5 = (value & 0b00100000)>>5;
    TRIS_DATA_PORT_6 = (value & 0b01000000)>>6;
    TRIS_DATA_PORT_7 = (value & 0b10000000)>>7;    
  }

BYTE my_get_data_port()
  {
    BYTE value;
    value = DATA_PORT_0 | DATA_PORT_1<<1 | DATA_PORT_2<<2 | DATA_PORT_3<<3 | DATA_PORT_4<<4 |DATA_PORT_5<<5 | DATA_PORT_6<<6 | DATA_PORT_7<<7;
    return value;
  }

BYTE my_get_tris_data_port()
  {
    BYTE value;
    value = TRIS_DATA_PORT_0 | TRIS_DATA_PORT_1<<1 | TRIS_DATA_PORT_2<<2 | TRIS_DATA_PORT_3<<3 | TRIS_DATA_PORT_4<<4 |TRIS_DATA_PORT_5<<5 | TRIS_DATA_PORT_6<<6 | TRIS_DATA_PORT_7<<7;
    return value;
  } 
   
// TRIS_DATA_PORT &= 0x0f;  
void my_tris_data_port_andeq(BYTE value)
  {
    BYTE current_value;
    current_value = my_get_tris_data_port();
    my_set_tris_data_port(current_value & value);
  }  


// TRIS_DATA_PORT &= 0x0f;  
void my_data_port_andeq(BYTE value)
  {
    BYTE current_value;
    current_value = my_get_data_port();
    my_set_data_port(current_value & value);
  }    

 
// TRIS_DATA_PORT |= 0x0f;  
void my_tris_data_port_oreq(BYTE value)
  {
    BYTE current_value;
    current_value = my_get_tris_data_port();
    my_set_tris_data_port(current_value | value);
  }  


// TRIS_DATA_PORT |= 0x0f;  
void my_data_port_oreq(BYTE value)
  {
    BYTE current_value;
    current_value = my_get_data_port();
    my_set_data_port(current_value | value);
  }    
   

 
// TRIS_DATA_PORT | 0x0f;  
BYTE my_tris_data_port_or(BYTE value)
  {
    BYTE current_value;
    current_value = my_get_tris_data_port();
    return (current_value | value);
  }  


// TRIS_DATA_PORT |= 0x0f;  
BYTE my_data_port_or(BYTE value)
  {
    BYTE current_value;
    current_value = my_get_data_port();
    return (current_value | value);
  }       
   


// TRIS_DATA_PORT & 0x0f;  
BYTE my_tris_data_port_and(BYTE value)
  {
    BYTE current_value;
    current_value = my_get_tris_data_port();
    return (current_value & value);
  }  


// TRIS_DATA_PORT |= 0x0f;  
BYTE my_data_port_and(BYTE value)
  {
    BYTE current_value;
    current_value = my_get_data_port();
    return (current_value & value);
  }       
  
 

